unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, DBGrids, DBCtrls,
  ExtCtrls, StdCtrls, LR_Class, LR_CodeReport, dmTest,LR_pgopt;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    e_PageFormatA: TDBComboBox;
    DBEdit1: TDBEdit;
    DBGrid1: TDBGrid;
    DBLookupComboBox1: TDBLookupComboBox;
    DBNavigator1: TDBNavigator;
    DBRadioGroup1: TDBRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lrCodeReport1: TlrCodeReport;
    pnlTop: TPanel;

    procedure Button1Click(Sender: TObject);
    procedure DBRadioGroup1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
     procedure PrepareLookupTable;
  public

  end;

var
  Form1: TForm1;

implementation

uses
  Printers,LR_Prntr,DB, LR_Const;

{$R *.lfm}

{ TForm1 }


procedure TForm1.FormCreate(Sender: TObject);
var
  i:integer;
  //frptr:TfrPrinter;
begin
  DataModuleTest:=TDataModuleTest.Create(self);
  DataModuleTest.PrepareData;
  DataModuleTest.BufDataset1.First;

  DBNavigator1.DataSource:=DataModuleTest.DataSource1;
  DBGrid1.DataSource:=DataModuleTest.DataSource1;

  DBEdit1.DataSource:=DataModuleTest.DataSource1;

  //TPrinterOrientation = (poPortrait,poLandscape,poReverseLandscape,poReversePortrait)
  DBRadioGroup1.DataSource:=DataModuleTest.DataSource1;
  DBRadioGroup1.Items.Clear;
  DBRadioGroup1.Items.Add('Portrait');
  DBRadioGroup1.Items.Add('Landscape');
  DBRadioGroup1.Items.Add('ReverseLandscape');
  DBRadioGroup1.Items.Add('ReversePortrait');

  // Code für eine Druckerauswahl
  //e_Printer.Items.Assign(Printer.Printers);
  // if e_Printer.Items.Count > 0 then
  //   e_Printer.ItemIndex := 0;


  // Page Format  A
  e_PageFormatA.DataSource:=DataModuleTest.DataSource1;
  e_PageFormatA.DataField:='PageFormatA';
  e_PageFormatA.Items.Clear;
  // That works without creating the Object becaus Prn is a Singleton Object and is created on Call
  // LR_Prntr Line 783 -- Printer Supported Formats Only
  LR_Prntr.Prn.FillPapers(e_PageFormatA.Items,false);  //Fill Papers without "Custom"

  DBLookupComboBox1.DataSource:=DataModuleTest.DataSource1;
  DBLookupComboBox1.ListSource:=DataModuleTest.DSLookup;
  DBLookupComboBox1.ListField:='Name';
  PrepareLookupTable;


end;

procedure TForm1.PrepareLookupTable;
var
  i:integer;
begin

{keine der beiden Varianten funktioniert, weil man (also ich) auf das Array Paperinfo nicht zugreifen kann}


 //Variante 1

  //for i := 0 to LR_Prntr.PAPERCOUNT - 1 do begin
  //   DataModuleTest.TLookup.Insert;
  //   DataModuleTest.TLookup.FieldByName('Name').AsString:= PaperInfo[i].Name;
  //   DataModuleTest.TLookup.FieldByName('Namelong').AsString:= ;
  //   DataModuleTest.TLookup.FieldByName('Typ').AsInteger:= PaperInfo[i].Typ;
  //   DataModuleTest.TLookup.FieldByName('X').AsInteger:= PaperInfo[i].X;
  //   DataModuleTest.TLookup.FieldByName('Y').AsInteger:= PaperInfo[i].Y;
  //   DataModuleTest.TLookup.Post;
  //   DataModuleTest.TLookup.ApplyUpdates;
  //end;


  //Variante 2
  //e_PageFormatA.Items.Clear;
  //for i := 0 to High(LR_Prntr.PaperInfo) do
  //  e_PageFormatA.Items.Add(LR_Prntr.PaperInfo[i].Name);

end;


procedure TForm1.DBRadioGroup1Change(Sender: TObject);
begin
  if DataModuleTest.BufDataset1.State in [dsEdit,dsInsert] then
    DataModuleTest.BufDataset1.FieldByName('Orientation_Int').AsInteger := DBRadioGroup1.ItemIndex;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  o:TfrPgoptForm;
begin
  o:=TfrPgoptForm.Create(self);
  o.showmodal;
  o.free;
end;

end.

